<?php
//企业微信接口

@ini_set('error_reporting', E_ALL & ~E_WARNING & ~E_NOTICE);
error_reporting(E_ALL & ~E_WARNING & ~E_NOTICE);

@header('Cache-Control: no-cache');
@header('Pragma: no-cache');

function authorize($corpid, $returnurl, $state) {
	$url = 'https://open.weixin.qq.com/connect/oauth2/authorize?appid='.urlencode($corpid).'&redirect_uri='.urlencode($returnurl).'&response_type=code&scope=snsapi_base&state='.urlencode($state).'#wechat_redirect';
	return $url;
}

function authed($token, $code) {
	$url = 'https://qyapi.weixin.qq.com/cgi-bin/user/getuserinfo?access_token='.urlencode($token).'&code='.urlencode($code);
	$content = curl_http_request($url);

	if ($content == false)
		return false;

	return json_decode($content, true);
}

function gettoken($corpid, $secret) {
	$url = 'https://qyapi.weixin.qq.com/cgi-bin/gettoken?corpid='.urlencode($corpid).'&corpsecret='.urlencode($secret);
	$content = curl_http_request($url);

	if ($content == false)
		return false;

	return json_decode($content, true);
}

function getuserinfo($token, $userid) {
//userid, name, avatar	
	$url = 'https://qyapi.weixin.qq.com/cgi-bin/user/get?access_token='.urlencode($token).'&userid='.$userid.'&lang=zh_CN';
	$content = curl_http_request($url);

	if ($content == false)
		return false;

	return json_decode($content, true);
}

function sendmsg($token, $to, $agentid, $data) {
	$url = 'https://qyapi.weixin.qq.com/cgi-bin/message/send?access_token='.urlencode($token);
	$post = array('touser' => $to,
					'msgtype' => 'news',
					'agentid' => $agentid,				  			 
					'news' => array(
						'articles'=> array(
							array(
								'title' => $data['title'],
								'description' => $data['content'],
								'url' => $data['url'],
								'picurl' => ''
							)
						)
					)
				);

	$content = curl_http_request($url, json_encode($post, JSON_UNESCAPED_UNICODE), 'POST');

	if ($content == false)
		return false;

	return json_decode($content, true);
}

function getticket($token) {
	$url = 'https://qyapi.weixin.qq.com/cgi-bin/get_jsapi_ticket?type=jsapi&access_token='.urlencode($token);
	
	$content = curl_http_request($url);

	if ($content == false)
		return false;

	return json_decode($content, true);
}


switch($_GET['mod']) {
default:
	echo '<!DOCTYPE html>
<html>
<head>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8">
<meta name="viewport" content="width=device-width, initial-scale=1, user-scalable=0, minimum-scale=1, maximum-scale=1">
</head>
<body>Invalid Method</body>
</html>';
	break;
case 'verify':
	include('../inc/config.php');
	include('../inc/config.settings.php');
	include('../inc/common.php');
	include('../inc/smssetup.php');

	$wxcfg = load_qywx_config();
	if ($wxcfg['corpid'] != '' && $wxcfg['secret'] != '' && $wxcfg['returnurl'] != '' && $wxcfg['token'] != '' && $wxcfg['aeskey'] != '') {
		include('../wxqy_sdk/wxbizmsgcrypt.php');
		
		$wxcpt = new WXBizMsgCrypt($wxcfg['token'], $wxcfg['aeskey'], $wxcfg['corpid']);
		if ($_GET['echostr']) {
			$signature = $_GET['msg_signature'];
			$timestamp = $_GET['timestamp'];
			$nonce = $_GET['nonce'];
			$echostr = $_GET['echostr'];

			$return = '';
			$errCode = $wxcpt->VerifyURL($signature, $timestamp, $nonce, $echostr, $return);
			if ($errCode == 0)
				echo $return;
			else
				echo 'ERR: '.$errCode;
		}
		else {
			echo 'ERR: echostr invalid';
		}
	}
	else {
		echo 'ERR: qywx settings error';
	}
	break;
case 'sign':
	include('../inc/config.php');
	include('../inc/config.settings.php');
	include('../inc/common.php');
	include('../inc/lib.php');
	include('../inc/class.session.php');
	include('../inc/class.sqlitedb.php');
	include('../inc/smssetup.php');

	$user = $_POST['user'];
	$pass = $_POST['pass'];
	$sessid = $_POST['sessid'];
	
	if (strlen($user) == 0 || strlen($pass) == 0 || strlen($sessid) == 0){
		echo 'username or password is empty!';
		exit;
	} 
	
	$user = trim(strtolower($user));
	$domain = '';
	$iPos = strpos($user, '@');
	if ($iPos !== false){
		$domain = substr($user, $iPos+1);
		$user = substr($user, 0, $iPos);
	}
	
	$domaininfo = load_domaininfo($domain);
	if ($domaininfo == false) {
		$aliasinfo = load_aliasdomaininfo($domain);
		if ($aliasinfo != false) {
			$aliasdomain = $aliasinfo['domain'];
			$domaininfo = load_domaininfo($aliasinfo['realdomain']);
		}
	}
	
	if ($domaininfo == false){
		echo 'domain not found';
		exit;
	}

	$sesshandle = New Session();
	$sesshandle->temp_folder = $SYSTEM_DIRECTORY['temporary'];
	$sesshandle->sessid = $sessid;
	$sesshandle->timeout = $session_timeout;
	$sesshandle->enable_cookies = false;
	$sesshandle->enable_ipcheck = false;
	
	$session_value = $sesshandle->Load(true);
	if (!is_array($session_value) || $session_value['qywxuserid'] == '' || time()-$session_value['start'] > 300) {
		echo 'invalid parameter';
		exit;
	}
	
	$domain = $domaininfo['domain'];
	
	if ($aliasdomain != '')
		$email = $user.'@'.$aliasdomain;
	else
		$email = $user.'@'.$domain;

	if ($domaininfo['type'] == 1)
		$userid = $user;
	else
		$userid = $user.'@'.$domain;
	
	$iError = check_user($userid, $pass, $userinfo, $errinfo);
	if ($iError == 0){
		if ($reg_flagchar == '3' || $reg_flagchar == 'C' || !$allow_setup_sms || $userinfo['smsnotify'] != 0) {
			echo 'not support new mail notification';
			exit;
		}

		my_setcookie('magicwinmail_openapi_login', '');
		
			$homedirectory = getmailhomedirectory($userid, $userinfo['mailstorepath'], $domaininfo['mailstorepath'], $mailstore_directory);
			if (substr($homedirectory, -1) != '\\')
				$homedirectory .= '\\';
			
			$session_value['userid'] = $userinfo['userid'];
			$session_value['email'] = $email;
			$session_value['homedirectory'] = $homedirectory;
			$session_value['homedirectory_utf8'] = sys_encode_utf8($homedirectory);
			
			$err = 2;
			$ret = bind_openapi_userid('qywx', $session_value['qywxuserid']);
			if ($ret === true)
				$err = 0;
			else if (is_string($ret))
				$err = 3;
		
		if ($err == 0) {
			$err = 4;
			$wxcfg = load_qywx_config();
			if ($wxcfg['corpid'] != '' && $wxcfg['secret'] != '' && $wxcfg['returnurl'] != '') {
				$accesstoken = $wxcfg['accesstoken'];
				if ($accesstoken == '' || time()-$wxcfg['tokentime'] > 3600) {
					$token = gettoken($wxcfg['corpid'], $wxcfg['secret']);
					if ($token && $token['access_token']) {
						$accesstoken = $token['access_token'];
					}
				}
			}
			
			$userinfo = getuserinfo($accesstoken, $session_value['qywxuserid']);
			if ($userinfo && $userinfo['errcode'] == 0) {
				if ($userinfo['name']) {
					update_smssetup('qywx', $userinfo);
				}
				
				if ($userinfo['status'] == 1) {
					$err = 0;
					
					$returnurl = trim($wxcfg['returnurl']);
					if (strncasecmp($returnurl, 'http://', 7) != 0 && strncasecmp($returnurl, 'https://', 8) != 0)
						$returnurl = 'http://'.$returnurl;
					if (substr($returnurl, -1) != '/')
						$returnurl .= '/';
					$returnurl .= 'qywx.php?mod=login';	
		
					$data = array('title' => '您已成功绑定邮箱帐号',
									'content' => $session_value['email'].'邮箱绑定成功。收到新邮件时，会给您发送微信消息',
									'url' => $returnurl);
									
					$send = sendmsg($accesstoken, $session_value['qywxuserid'], $wxcfg['agentid'], $data);
				}
				else {
					$err = 5;
				}
			}
			else {
				$ret = $userinfo['errcode'].' - '.$userinfo['errmsg'];
			}
		}
		
		$errText = array(
			0 => '新邮件通知已经绑定成功。',
			1 => '传入参数错误！',
			2 => '保存微信 ID 失败！',
			3 => '您已经绑定其他邮箱('.$ret.')，不能重复绑定！',
			4 => '新邮件通知已经绑定成功<br>
从微信获取用户信息失败，请联系管理员检查是否有读取通讯录权限('.$ret.')。',
			5 => '新邮件通知已经绑定成功<br>
您的帐号状态异常，不能收到新邮件通知。',
		);
	
		echo '<!DOCTYPE html>
<html>
<head>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8">
<meta name="viewport" content="width=device-width, initial-scale=1, user-scalable=0, minimum-scale=1, maximum-scale=1">
</head>
<body>'.$errText[$err].'</body>
</html>';
	}
	else{
		echo '<!DOCTYPE html>
<html>
<head>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8">
<meta name="viewport" content="width=device-width, initial-scale=1, user-scalable=0, minimum-scale=1, maximum-scale=1">
</head>
<body>登录失败！检查用户名和密码是否正确(err: '.$iError.')</body>
</html>';
	}

	break;
case 'authed':
	$err = 1;
	$code = $_GET['code'];
	$state = $_GET['state'];

	if ($code != '' && $state != '') {
		$err = 1;
		$pos = strpos($state, '-');
		if ($pos != false) {
			$sessid = substr($state, 0, $pos);
			$userid = substr($state, $pos+1);
			
			$pos = strrpos($userid, '#');
			if ($pos != false) {
				$userid = substr($userid, 0, $pos);
			}
		}
		
		if ($sessid != '' && $userid != '') 
			$err = 0;
	}
	
	if ($err == 0) {
		$err = 2;
		include('../inc/config.php');
		include('../inc/config.settings.php');
		include('../inc/common.php');
		include('../inc/class.session.php');
		include('../inc/class.sqlitedb.php');
		include('../inc/smssetup.php');
		
		$sesshandle = New Session();
		$sesshandle->temp_folder = $SYSTEM_DIRECTORY['temporary'];
		$sesshandle->sessid = $sessid;
		$sesshandle->timeout = $session_timeout;
		$sesshandle->enable_cookies = false;
		$sesshandle->enable_ipcheck = false;
		
		$session_value = $sesshandle->Load(true);
		if ($session_value && $session_value['auth'] && is_numeric($session_value['userid']) 
			&& $session_value['uid'] != '' && $session_value['homedirectory'] != '') {
			if ($session_value['uid'] == $userid) {
				$err = 0;
				my_setcookie('magicwinmail_openapi_login', '');
			}
		}
	}
	
	if ($err == 0) {
		$err = 3;
		$wxcfg = load_qywx_config();
		if ($wxcfg['corpid'] != '' && $wxcfg['secret'] != '' && $wxcfg['returnurl'] != '') {
			$accesstoken = $wxcfg['accesstoken'];
			if ($accesstoken == '' || time()-$wxcfg['tokentime'] > 3600) {
				$token = gettoken($wxcfg['corpid'], $wxcfg['secret']);
				if ($token && $token['access_token']) {
					$accesstoken = $token['access_token'];
				}
			}
			
			$err = 4;
			$auth = authed($accesstoken, $code);
			if ($auth && $auth['UserId']) {
				$err = 5;
				$ret = bind_openapi_userid('qywx', $auth['UserId']);
				if ($ret === true)
					$err = 0;
				else if (is_string($ret))
					$err = 6;
			}
			else {
				if ($auth['OpenId'] != '')
					$ret = '非企业成员';
				else
					$ret = $auth['errcode'].' - '.$auth['errmsg'];
			}
		}
	}
	
	if ($err == 0) {
		$err = 7;

		$userinfo = getuserinfo($accesstoken, $auth['UserId']);
		if ($userinfo && $userinfo['errcode'] == 0) {
			if ($userinfo['name']) {
				update_smssetup('qywx', $userinfo);
			}
			
			if ($userinfo['status'] == 1) {
				$err = 0;
				
				$returnurl = trim($wxcfg['returnurl']);
				if (strncasecmp($returnurl, 'http://', 7) != 0 && strncasecmp($returnurl, 'https://', 8) != 0)
					$returnurl = 'http://'.$returnurl;
				if (substr($returnurl, -1) != '/')
					$returnurl .= '/';
				$returnurl .= 'qywx.php?mod=login';	
	
				$data = array('title' => '您已成功绑定邮箱帐号',
								'content' => $session_value['email'].'邮箱绑定成功。收到新邮件时，会给您发送微信消息',
								'url' => $returnurl);
								
				$send = sendmsg($accesstoken, $auth['UserId'], $wxcfg['agentid'], $data);
			}
			else {
				$err = 8;
			}
		}
		else {
			$ret = $userinfo['errcode'].' - '.$userinfo['errmsg'];
		}
	}
	
	$errText = array(
		0 => '新邮件通知已经绑定成功。',
		1 => '传入参数错误！',
		2 => 'Webmail 会话已经超时，请重试登录再绑定！',
		3 => '读取微信配置参数置失败！',
		4 => '获取企业成员信息失败('.$ret.')<br>
请联系管理员加入企业微信<br><br>
如果您还没有关注此企业微信，请先关注。关注完成后，请重新扫描绑定<br>
<img src="customer/qywx.jpg?'.md5(microtime()).'"><br>
长按识别二维码，加关注。',
		5 => '保存微信 ID 失败！',
		6 => '您已经绑定其他邮箱('.$ret.')，不能重复绑定！',
		7 => '新邮件通知已经绑定成功<br>
从微信获取用户信息失败，请联系管理员检查是否有读取通讯录权限('.$ret.')<br><br>
如果您还没有关注此企业微信，请先关注<br>
<img src="customer/qywx.jpg?'.md5(microtime()).'"><br>
长按识别二维码，加关注。',
		8 => '新邮件通知已经绑定成功<br>
您的帐号状态异常，不能收到新邮件通知<br><br>
如果您还没有关注此企业微信，请先关注<br>
<img src="customer/qywx.jpg?'.md5(microtime()).'"><br>
长按识别二维码，加关注。',
	);
	
	echo '<!DOCTYPE html>
<html>
<head>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8">
<meta name="viewport" content="width=device-width, initial-scale=1, user-scalable=0, minimum-scale=1, maximum-scale=1">
</head>
<body>'.$errText[$err].'</body>
</html>';
	break;
case 'login':
case 'folder':
case 'read':
case 'msglist':
case 'compose':
case 'unbind':
case 'test':
	include('../inc/config.php');
	include('../inc/config.settings.php');
	include('../inc/common.php');
	include('../inc/smssetup.php');

	$wxcfg = load_qywx_config();
	if ($wxcfg['corpid'] != '' && $wxcfg['secret'] != '' && $wxcfg['returnurl'] != '') {
		$returnurl = trim($wxcfg['returnurl']);
		if (strncasecmp($returnurl, 'http://', 7) != 0 && strncasecmp($returnurl, 'https://', 8) != 0)
			$returnurl = 'http://'.$returnurl;
		if (substr($returnurl, -1) != '/')
			$returnurl .= '/';
		$returnurl .= 'qywx.php?mod='.$_GET['mod'].'_submit';	
		
		if ($_GET['mod'] == 'read')
			$state = $_GET['msgid'];
		else
			$state = md5(uniqid(microtime(), true));

		$url = authorize($wxcfg['corpid'], $returnurl, $state);
		Header('Location: '.$url);
	}
	else {
		echo '<!DOCTYPE html>
<html>
<head>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8">
<meta name="viewport" content="width=device-width, initial-scale=1, user-scalable=0, minimum-scale=1, maximum-scale=1">
</head>
<body>企业微信参数设置错误，请联系管理员检查</body>
</html>';
	}
	
	break;
case 'login_submit':
case 'folder_submit':
case 'msglist_submit':
case 'compose_submit':
case 'read_submit':
	include('../inc/config.php');
	include('../inc/init.php');
	include('../inc/config.settings.php');
	include('../inc/common.php');
	include('../inc/header.php');
	include('../inc/cookie.php');
	include('../inc/global.php');
	include('../inc/lib.php');
	include('../inc/update.php');
	include('../inc/class.mailfolder.php');
	include('../inc/class.message.php');
	include('../inc/class.session.php');
	include('../inc/class.userstat.php');
	include('../inc/folderlib.php');
	include('../inc/smssetup.php');

	$retid = (double)microtime()*100000000;
	
	$code = $_GET['code'];
	$state = $_GET['state'];
	$wxuserid = '';
	$wxticket = '';
	
	if ($code != '' && $state != '') {
		$wxcfg = load_qywx_config();
		if ($wxcfg['corpid'] != '' && $wxcfg['secret'] != '' && $wxcfg['returnurl'] != '') {
			$accesstoken = $wxcfg['accesstoken'];
			if ($accesstoken == '' || time()-$wxcfg['tokentime'] > 3600) {
				$token = gettoken($wxcfg['corpid'], $wxcfg['secret']);
				if ($token && $token['access_token']) {
					$accesstoken = $token['access_token'];
				}
			}
			
			$auth = authed($accesstoken, $code);
			if ($auth && $auth['UserId']) {
				$wxuserid = $auth['UserId'];
			}
			
			$jsticket = getticket($accesstoken);
			if ($jsticket && $jsticket['ticket']) {
				$wxticket = $jsticket['ticket'];
			}
			
			//解决同一个 code 两次访问，第二次返回 code 已用的错误
			$sesshandle = New Session();
			$sesshandle->temp_folder = $SYSTEM_DIRECTORY['temporary'];
			$sesshandle->sessid = md5($code.'|'.$state);
			$sesshandle->sesstype = SESSION_CODE;	
			$sesshandle->timeout = 600;
			$sesshandle->enable_cookies = false;
			$sesshandle->enable_ipcheck = false;
			if ($wxuserid == '') {
				$sess_value = $sesshandle->Load();
				if (is_array($sess_value) && $sess_value['code'] == $code) {
					$wxuserid = $sess_value['userid'];
					$wxticket = $sess_value['ticket'];

					$sesshandle->Kill();
				}
			}
			else {
				$sess_value = array();
				$sess_value['code'] = $code;
				$sess_value['userid'] = $wxuserid;
				$sess_value['ticket'] = $wxticket;
				
				$sesshandle->Save($sess_value);
			}
			
			unset($sesshandle);
		}
	}
	
	if ($wxuserid != '') {
		$logined = false;
		$logininfo = $_COOKIE['magicwinmail_openapi_login'];
		if ($logininfo != '') {
			$decode = base64_decode($logininfo);
			$value = unserialize($decode);
		
			if (strcmp($value['openapi_userid'], $wxuserid) == 0 && strcmp($value['openapi_appid'], md5($wxcfg['corpid'])) == 0) {
				$sessid = $value['sessid'];
				
				$sesshandle = New Session();
				$sesshandle->temp_folder = $SYSTEM_DIRECTORY['temporary'];
				$sesshandle->sessid = $sessid;
				$sesshandle->timeout = $session_timeout;
				$sesshandle->enable_cookies = false;
				$sesshandle->enable_ipcheck = false;
				
				$session_value = $sesshandle->Load(true);
				if (is_array($session_value) && $session_value['auth'] && $session_value['openapi_auth'] 
					&& strcasecmp($session_value['uid'], $value['uid']) == 0
					&& strcmp($session_value['openapi_userid'], $value['openapi_userid']) == 0
					&& intval(time() - $session_value['start']) < $session_timeout) {
					$logined = true;
					my_setcookie('magicwinmail_openapi_login', $logininfo, 600);
		
					$session_value['openapi_cookie'] = true;
					$session_value['openapi_ticket'] = $wxticket;
					$session_value['start'] = time();
					$sesshandle->Save($session_value);
				}
			}
		}
		
		if (!$logined) {
			$iError = check_openapi_user('weixin', $wxuserid, $userinfo, $errinfo);
			if ($iError >= 0){
				$user = $userinfo['name'];
				$domain = $userinfo['domain'];
				$pass = md5($wxuserid);
				
				$userid = $user;
				if ($domain != '')
					$userid .= '@'.$domain;
	
				$alldomains = load_alldomain();
				$domaincount = count($alldomains);
				for ($i = 0; $i < $domaincount; $i++) {
					if (strcasecmp($alldomains[$i]['domain'], $domain) == 0
						|| ($domain == '' && $alldomains[$i]['type'] == 1)){
						$domain = $alldomains[$i]['domain'];
						$domaininfo = $alldomains[$i];
						break;
					}
				}
				
				$email = $user.'@'.$domain;
				
				$homedirectory = getmailhomedirectory($userid, $userinfo['mailstorepath'], $domaininfo['mailstorepath'], $mailstore_directory);
				if (substr($homedirectory, -1) != '\\')
					$homedirectory .= '\\';
			
				$stathandle = new UserStat($homedirectory);
				$stathandle->Init();
				if ($iError == 0)
					$lastvisit = $stathandle->GetVisitStat();
			
				$info = array();
				$info['type'] = 'Weixin';
				$info['action'] = $errinfo;
				
				$stathandle->AddVisit($info);
			}
			
			if ($iError == 0){
				$sesshandle = New Session();
				$sesshandle->temp_folder = $SYSTEM_DIRECTORY['temporary'];
				
				$sessid = $sesshandle->GenSessionID($wxuserid);
				if ($sessid == false){
					echo 'Error: create session error';
					exit;
				}
			
				$sesshandle->sessid = $sessid;
				$sesshandle->timeout = $session_timeout;
				$sesshandle->enable_cookies = false;
				$sesshandle->enable_ipcheck = false;
			
				$session_value = array();
				$session_value['session_id'] = $sessid;
//				$session_value['session_token'] = $sesshandle->GenToken($sessid);
				
				$session_value['auth'] = true;
				$session_value['start'] = time();

				$session_value['openapi_auth'] = true;
				$session_value['openapi_cookie'] = false;
				$session_value['openapi_userid'] = $wxuserid;
				$session_value['openapi_appid'] = $wxcfg['corpid'];
				$session_value['openapi_ticket'] = $wxticket;
				$session_value['openapi_type'] = 'weixin';
				
				$session_value['lid'] = $lid;
				$session_value['tid'] = $theme_mobile_inx;
			
				$session_value['userid'] = $userinfo['userid'];
				$session_value['uid'] = $userid;
				$session_value['user'] = $userinfo['name'];
				$session_value['domain'] = $userinfo['domain'] ? $userinfo['domain'] : $domaininfo['domain'];
				$session_value['pass'] = Crypt_Encode($pass);
				$session_value['email'] = $session_value['user'].'@'.$session_value['domain'];
				$session_value['dispemail'] = decode_punycode_mail($session_value['email']);
				
				$session_value['fullname'] = $userinfo['fullname'];
				$session_value['mobile'] = $userinfo['mobile'];
				$session_value['company'] = $userinfo['company'];
				$session_value['department'] = $userinfo['department'];
				$session_value['jobtitle'] = $userinfo['jobtitle'];
				$session_value['office'] = $userinfo['office'];
				$session_value['officephone'] = $userinfo['officephone'];
				$session_value['homeaddress'] = $userinfo['homeaddress'];
				$session_value['homephone'] = $userinfo['homephone'];
				
				$session_value['authtype'] = $userinfo['authtype'];
				$session_value['expiretime'] = $userinfo['expiretime'];
				$session_value['createtime'] = $userinfo['createtime'];

				$session_value['modifyuserinfo'] = 1;			//no password, password is weixin ID
				$session_value['externalpop3'] = $userinfo['externalpop3'];
				$session_value['autoforward'] = $userinfo['autoforward'];
				$session_value['autoreply'] = $userinfo['autoreply'];
				$session_value['spamcontrol'] = $userinfo['spamcontrol'];
				$session_value['publiccontact'] = $userinfo['publiccontact'];
				$session_value['netdiskcontrol'] = $userinfo['netdiskcontrol'];
				$session_value['calendarcontrol'] = $userinfo['calendarcontrol'];
				$session_value['notebookcontrol'] = $userinfo['notebookcontrol'];
				$session_value['smsnotify'] = $userinfo['smsnotify'];
				$session_value['sendsms'] = 1;
				$session_value['deletemsg'] = $userinfo['deletemsg'];
				$session_value['archive'] = $userinfo['archive'];
				$session_value['pushmail'] = $userinfo['pushmail'];
			
				$session_value['chgpassword'] = 0x01;				//no password, password is weixin ID
				$session_value['pwdexpiredays'] = $userinfo['pwdexpiredays'];
			
				$session_value['pwdlength'] = $domaininfo['pwdlength'];
				$session_value['pwdlevel'] = $domaininfo['pwdlevel'];
				$session_value['lastchgpwdtime'] = $userinfo['lastchgpwdtime'];
			
				$session_value['spamassassin'] = $userinfo['spamassassin'];
				$session_value['spamdealing'] = $userinfo['spamdealing'];
			
				$session_value['secretlevel'] = $userinfo['secretlevel'];
			
				$session_value['mailquota'] = $userinfo['mailquota'];
				$session_value['mailcount'] = $userinfo['mailcount'];
				$session_value['ftpquota'] = $userinfo['ftpquota'];
				$session_value['ftpcount'] = $userinfo['ftpcount'];

				$session_value['maxmsgsize'] = $userinfo['maxmsgsize'];
			
				$session_value['lastvisit'] = $lastvisit;
			
				$session_value['homedirectory'] = $homedirectory;
				$session_value['homedirectory_utf8'] = sys_encode_utf8($homedirectory);
				
				$ftphomedirectory = getmailhomedirectory($userid, $userinfo['ftpstorepath'], $domaininfo['ftpstorepath'], $ftpstore_directory);
				if (substr($ftphomedirectory, -1) != '\\')
					$ftphomedirectory .= '\\';
			
				$session_value['ftphomedirectory'] = $ftphomedirectory;
			
				$session_value['preferences'] = load_prefs();
				$session_value['publicfolderlist'] = GetPublicFolderList();
				
				$session_value['smsfunction'] = $sms_function;
				if ($sms_function) {
					$session_value['smsfunction'] = get_sms_right($sms);
					if (!$sms)
						$session_value['sendsms'] = 1;
				}
				
				switch($reg_flagchar) {
				default:
					$session_value['versiontype'] = 0;
					break;
				case '1':
				case 'A':
					$session_value['versiontype'] = 1;
					break;
				case '2':
				case 'B':
					$session_value['versiontype'] = 2;
					break;
				case '3':
				case 'C':
					$session_value['versiontype'] = 3;
					break;
				case '4':
				case 'D':
					$session_value['versiontype'] = 4;
					break;
				}
				
				if ($session_value['versiontype'] == 3) {
					$session_value['publicfolderlist'] = array();
					$session_value['publiccontact'] = 1;
					
					$session_value['netdiskcontrol'] = 0;
					$session_value['calendarcontrol'] = 0;
					$session_value['notebookcontrol'] = 0;
					
					$session_value['smsfunction'] = false;
				}

				if ($session_value['versiontype'] != 2) {
					$session_value['secretlevel'] = 0;
				}
				
				$session_value['cust_company'] = $domaininfo['company'];
				$session_value['cust_website'] = $domaininfo['website'];

				if ($session_value['versiontype'] != 3 && $domaininfo['logoimage'] != '') 
					$session_value['cust_logoimage'] = create_domain_logoimage($domain, $domaininfo['logoimage']);
			
				$sesshandle->Save($session_value);
			
				$value = array();
				$value['sessid'] = $sessid;
				$value['uid'] = $session_value['uid'];
				$value['openapi_userid'] = $session_value['openapi_userid'];
				$value['openapi_appid'] = md5($session_value['openapi_appid']);

				$content = serialize($value);
				$encode = base64_encode($content);
				my_setcookie('magicwinmail_openapi_login', $encode, 600);

				UpdateVersion();
				InitUserDB();

				$logined = true;
			}
		}
		
		if ($logined) {
			$publicfolder_directory	 = $mailstore_directory.'@PubMBox\\';
		
			$folderhandle = new MailFolder();
			$folderhandle->debug = $enable_debug;
			$folderhandle->public_directory = $publicfolder_directory;
			$folderhandle->public_folders = $session_value['publicfolderlist'];
			$folderhandle->home_directory = $session_value['homedirectory'];
			$folderhandle->system_folders = $system_folders;
			$folderhandle->check_system_folders();
		
			$msghandle = new Message();
			$msghandle->debug = $enable_debug;
			$msghandle->temp_folder = $SYSTEM_DIRECTORY['temporary'];
			$msghandle->check_temp_folder();
			
			$locate = 'main';
			$urlpara = '';
			if ($_GET['mod'] == 'msglist_submit') {
				$locate = 'msglist';
			}
			else if ($_GET['mod'] == 'folder_submit') {
				$locate = 'folders';
			}
			else if ($_GET['mod'] == 'compose_submit') {
				$locate = 'newmsg';
			}
			else if ($_GET['mod'] == 'read_submit') {
				$locate = 'readmsg';
				$urlpara .= '&urlpara='.base64_encode('folder=INBOX&msgid='.intval($state));
			}
			
			Header('Location: main.php?sessid='.$sessid.'&retid='.$retid.'&gotopage='.$locate.$urlpara); 
			exit;
		}
		
		$sesshandle = New Session();
		$sesshandle->temp_folder = $SYSTEM_DIRECTORY['temporary'];
		
		$sessid = $sesshandle->GenSessionID($wxuserid);
		if ($sessid == false){
			echo 'Error: create session error';
			exit;
		}
		$sesshandle->sessid = $sessid;
		$sesshandle->timeout = $session_timeout;
		$sesshandle->enable_cookies = false;
		$sesshandle->enable_ipcheck = false;
	
		$session_value = array();
		$session_value['qywxuserid'] = $wxuserid;
		$session_value['start'] = time();
		$sesshandle->Save($session_value);

		echo '<!DOCTYPE html>
<html>
<head>
<title>登录邮箱绑定微信</title>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8">
<meta name="viewport" content="width=device-width, initial-scale=1, user-scalable=0, minimum-scale=1, maximum-scale=1">
<style>
html, body {margin:0;padding:0;width:100%; height:100%; text-align:center; font-family:"Microsoft YaHei",Arial,sans-serif,Tahoma; font-size:14px; background-color:#FFFFFF;}
form {padding:0;margin:50px auto; text-align:center; width:90%}
input {height:30px; width:100%; margin:10px 0; border:1px solid #bbb; -webkit-border-radius:3px; }
input[type="text"],input[type="password"] {color:#666; background-color:#fff;}
input[type="button"] {height:40px; font-weight:bold; border:0; color:#fff; background-color:#318ADE;}
</style>
</head>
<body>
<form name="form1" action="qywx.php?mod=sign" method="post">
<input type="hidden" name="sessid" value="'.$sessid.'">
<input type="text" name="user" placeholder="邮箱地址">
<input type="password" name="pass" placeholder="密码">
<input type="button" name="login" value="登录" onclick="javascript:loginCheck();">
</form>
<script>
function loginCheck() {
	var frm = document.form1;
	if (frm.user.value == "" || frm.pass.value == "") {
		alert("邮箱地址和密码不能为空！");
		return;
	}
	
	frm.submit();
}
</script>
</body>
</html>';
	}
	else {
		Header('Location: index.php'); 
	}
	
	break;
case 'unbind_submit':
	include('../inc/config.php');
	include('../inc/config.settings.php');
	include('../inc/common.php');
	include('../inc/class.sqlitedb.php');
	include('../inc/smssetup.php');
	
	$code = $_GET['code'];
	$state = $_GET['state'];
	$err = 1;
	
	if ($code != '' && $state != '') {
		$wxcfg = load_qywx_config();
		if ($wxcfg['corpid'] != '' && $wxcfg['secret'] != '' && $wxcfg['returnurl'] != '') {
			$accesstoken = $wxcfg['accesstoken'];
			if ($accesstoken == '' || time()-$wxcfg['tokentime'] > 3600) {
				$token = gettoken($wxcfg['corpid'], $wxcfg['secret']);
				if ($token && $token['access_token']) {
					$accesstoken = $token['access_token'];
				}
			}
			
			$auth = authed($accesstoken, $code);
			if ($auth && $auth['UserId']) {
				if (unbind_openapi_userid('weixin', $auth['UserId']))
					$err = 0;
					
				my_setcookie('magicwinmail_openapi_login', '');
			}
		}
	}
	
	$errText = array(
		0 => '解除绑定成功。',
		1 => '解除绑定失败。'
	);
	
	echo '<!DOCTYPE html>
<html>
<head>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8">
<meta name="viewport" content="width=device-width, initial-scale=1, user-scalable=0, minimum-scale=1, maximum-scale=1">
</head>
<body>'.$errText[$err].'</body>
</html>';
	break;
case 'test_submit':
	include('../inc/config.php');
	include('../inc/config.settings.php');
	include('../inc/common.php');
	include('../inc/smssetup.php');
	
	$code = $_GET['code'];
	$state = $_GET['state'];
	$err = 1;
	
	if ($code != '' && $state != '') {
		$wxcfg = load_qywx_config();
		if ($wxcfg['corpid'] != '' && $wxcfg['secret'] != '' && $wxcfg['returnurl'] != '') {
			$accesstoken = $wxcfg['accesstoken'];
			if ($accesstoken == '' || time()-$wxcfg['tokentime'] > 3600) {
				$token = gettoken($wxcfg['corpid'], $wxcfg['secret']);
				if ($token && $token['access_token']) {
					$accesstoken = $token['access_token'];
				}
			}
			
			$err = 2;
			$auth = authed($accesstoken, $code);
			if ($auth && $auth['UserId']) {
				$err = 0;
			}
			else {
				if ($auth['OpenId'] != '')
					$ret = '非企业成员';
				else
					$ret = $auth['errcode'].' - '.$auth['errmsg'];
			}
		}
	}

	if ($err == 0) {
		$err = 3;
		
		$userinfo = getuserinfo($accesstoken, $auth['UserId']);
		if ($userinfo && $userinfo['errcode'] == 0) {
			if ($userinfo['name']) {
				update_smssetup('qywx', $userinfo);
			}
		
			if ($userinfo['status'] == 1) {
				$err = 0;
				
				$returnurl = trim($wxcfg['returnurl']);
				if (strncasecmp($returnurl, 'http://', 7) != 0 && strncasecmp($returnurl, 'https://', 8) != 0)
					$returnurl = 'http://'.$returnurl;
				if (substr($returnurl, -1) != '/')
					$returnurl .= '/';
				$returnurl .= 'qywx.php?mod=login';	
	
				$data = array('title' => '这是一封微信测试通知',
								'content' => $session_value['email'].'邮箱绑定成功。',
								'url' => $returnurl);
								
				$send = sendmsg($accesstoken, $auth['UserId'], $wxcfg['agentid'], $data);
			}
			else {
				$err = 4;
			}
		}
		else {
			$ret = $userinfo['errcode'].' - '.$userinfo['errmsg'];
		}
	}
	
	$errText = array(
		0 => '测试信息发送成功！',
		1 => '传入参数错误！',
		2 => '获取成员信息失败('.$ret.')<br>
请联系管理员加入企业微信。',
		3 => '测试信息发送失败！<br>
从微信获取用户信息失败，请联系管理员检查是否有读取通讯录权限('.$ret.')',
		4 => '测试信息发送失败！<br>
您的帐号状态异常，请联系管理员检查！',
	);
	
	echo '<!DOCTYPE html>
<html>
<head>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8">
<meta name="viewport" content="width=device-width, initial-scale=1, user-scalable=0, minimum-scale=1, maximum-scale=1">
</head>
<body>'.$errText[$err].'</body>
</html>';
	break;
}

?>